"{ Package: 'stx:goodies/monticello' }"

Object subclass:#MCPatcher
	instanceVariableNames:'definitions'
	classVariableNames:''
	poolDictionaries:''
	category:'Monticello-Patching'
!


!MCPatcher class methodsFor:'as yet unclassified'!

apply: aPatch to: aSnapshot
	| loader |
	loader := self snapshot: aSnapshot.
	aPatch applyTo: loader.
	^ loader patchedSnapshot
!

snapshot: aSnapshot
	^ self new initializeWithSnapshot: aSnapshot
! !

!MCPatcher methodsFor:'as yet unclassified'!

addDefinition: aDefinition
	definitions add: aDefinition
!

initializeWithSnapshot: aSnapshot
	definitions := MCDefinitionIndex definitions: aSnapshot definitions
!

modifyDefinition: baseDefinition to: targetDefinition
	self addDefinition: targetDefinition
!

patchedSnapshot
	^ MCSnapshot fromDefinitions: definitions definitions
!

removeDefinition: aDefinition
	definitions remove: aDefinition
! !

!MCPatcher class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCPatcher.st,v 1.3 2011-08-20 12:31:21 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCPatcher.st,v 1.3 2011-08-20 12:31:21 cg Exp $'
!

version_SVN
    ^ 'Id: MCPatcher.st 5 2010-08-29 07:30:29Z vranyj1 '
! !
